﻿local old_QuestFrameDetailPanel_OnShow;
local old_QuestLog_UpdateQuestDetails;
local old_QuestFrameProgressPanel_OnShow;
local old_QuestFrameRewardPanel_OnShow;
local old_ItemTextFrame_OnEvent;
local old_ChatFrame_OnEvent;
local old_GossipFrameOptionsUpdate;
local old_GossipFrameUpdate;
local oldTooltipText;
RUWOW_EnableQuests=true;
RUWOW_EnableSpells=true;
RUWOW_EnableBooks=true;
RUWOW_EnableCreatures=true;
RUWOW_EnableNPCs=true;
RUWOW_EnableInterface=true;
RUWOW_EnableCombatLog=true;
local oldClassTrainerSkillDescription;
local oldClassTrainerGreetingText;
local event;
local msg;
local abc;
local j;
local str;
local str1;
local tmp;

local trim=function(text)
	if not text then return nil; end
	return gsub(gsub(gsub(string.lower(text), "%s+", " "), "%s+$", ""), "^%s+", "");
end

local prepare=function(text)
	return gsub(text, strchar(36)..strchar(66), strchar(10));
end

RuWoW_OnLoad=function()
	SLASH_RUWOW1="/ruwow";
	SlashCmdList["RUWOW"]=RuWoW_CMD;
	this:RegisterEvent("VARIABLES_LOADED");
	local a="";
	if RUWOW_QuestObjective then a=a..RUWOW_QuestObjective.." квестов. ";end
	if not RUWOW_EnableQuests then a=a.."|c00ff0000 Квесты выключены!|r ";end
	if RUWOW_SpellDescription then a=a..RUWOW_SpellDescription.." заклинаний. ";end
	if not RUWOW_EnableSpells then a=a.."|c00ff0000 Заклинания выключены!|r ";end
	if RUWOW_BookPage then a=a..RUWOW_BookPage.." страниц книг. ";end
	if not RUWOW_EnableBooks then a=a.."|c00ff0000 Книги выключены!|r ";end
	if RUWOW_Creature then a=a..RUWOW_Creature.." текстов существ. ";end
	if not RUWOW_EnableCreatures then a=a.."|c00ff0000 Существа выключены!|r ";end
	if RUWOW_NPCText then a=a..RUWOW_NPCText.." текстов NPC. ";end
	if not RUWOW_EnableNPCs then a=a.."|c00ff0000 NPC выключены!|r ";end
	DEFAULT_CHAT_FRAME:AddMessage("RuWoW загружен. "..a);
	if RUWOW_disableforthischar then DEFAULT_CHAT_FRAME:AddMessage("|c00ff0000Перевод не будет работать у этого персонажа.|r");end
end

RuWoW_OnEvent=function(event)
	if type(RUWOW_LocalizeCombatLog)=="function" then RUWOW_LocalizeCombatLog() end
	if type(RUWOW_LocalizeInterface)=="function" then RUWOW_LocalizeInterface() end
end
abc=strchar(82, 117, 87, 111, 87);


    
local RuWoW_Update_Texts=function()
	if QuestFrameProgressPanel:IsVisible() then QuestFrameProgressPanel_OnShow(); end
	if QuestFrameRewardPanel:IsVisible() then QuestFrameRewardPanel_OnShow(); end
	if QuestFrameDetailPanel:IsVisible() then QuestFrameDetailPanel_OnShow(); end
	QuestLog_UpdateQuestDetails();
end

abc=abc..strchar(100+15);
local Show_Status=function()
	local a="";
	if not RUWOW_EnableQuests then a=a.."Квесты |c00ff0000выключены|r. "; else a=a.."Квесты включены. "end
	if not RUWOW_EnableSpells then a=a.."Заклинания |c00ff0000выключены|r. "; else a=a.."Заклинания включены. "end
	if not RUWOW_EnableBooks then a=a.."Книги |c00ff0000выключены|r. "; else a=a.."Книги включены. "end
	if not RUWOW_EnableCreatures then a=a.."Существа |c00ff0000выключены|r. "; else a=a.."Существа включены. "end
	if not RUWOW_EnableNPCs then a=a.."Npc |c00ff0000выключены|r. "; else a=a.."Npc включены. "end
	if not RUWOW_EnableInterface then a=a.."Интерфейс |c00ff0000выключен|r. "; else a=a.."Интерфейс включен. "end
	if not RUWOW_EnableCombatLog then a=a.."Лог боя |c00ff0000выключен|r. "; else a=a.."Лог боя включен. "end
	DEFAULT_CHAT_FRAME:AddMessage(a);
end

abc=abc..strchar(100+16); 
RuWoW_CMD=function(msg)
	if msg=="quests" then
		RUWOW_EnableQuests=not RUWOW_EnableQuests;
		RuWoW_Update_Texts(); 
		Show_Status();
	elseif msg=="spells" then
		RUWOW_EnableSpells=not RUWOW_EnableSpells;
		oldTooltipText="";
		oldClassTrainerSkillDescription="";
		oldClassTrainerGreetingText="";
		Show_Status();
	elseif msg=="books" then
		RUWOW_EnableBooks=not RUWOW_EnableBooks;
		ItemTextFrame_OnEvent("ITEM_TEXT_READY");
		Show_Status();
	elseif msg=="creatures" then
		RUWOW_EnableCreatures=not RUWOW_EnableCreatures;
		Show_Status();
	elseif msg=="npcs" then
		RUWOW_EnableNPCs=not RUWOW_EnableNPCs;
		GossipFrameUpdate();
		Show_Status();
	elseif msg=="interface" then
		RUWOW_EnableInterface=not RUWOW_EnableInterface;
		RUWOW_LocalizeInterface();
		Show_Status();
	elseif msg=="combatlog" then
		RUWOW_EnableCombatLog=not RUWOW_EnableCombatLog;
		RUWOW_LocalizeCombatLog();
		Show_Status();
	elseif msg=="show" then
		Show_Status();
	else
		DEFAULT_CHAT_FRAME:AddMessage("/ruwow quests - включает/выключает перевод квестов");
		DEFAULT_CHAT_FRAME:AddMessage("/ruwow spells - включает/выключает перевод спеллов");
		DEFAULT_CHAT_FRAME:AddMessage("/ruwow books - включает/выключает перевод книг");
		DEFAULT_CHAT_FRAME:AddMessage("/ruwow monsters - включает/выключает перевод монстров");
		DEFAULT_CHAT_FRAME:AddMessage("/ruwow npcs - включает/выключает перевод монстров");
		DEFAULT_CHAT_FRAME:AddMessage("/ruwow interface - включает/выключает перевод интерфейса");
		DEFAULT_CHAT_FRAME:AddMessage("/ruwow combatlog - включает/выключает перевод лога боя");
		DEFAULT_CHAT_FRAME:AddMessage("/ruwow show - показывает текущие настройки");
	end
end
abc=abc..strchar(100+14); 

local SpellTranslate=function(text)
	if type(text)~="string" then return nil end
	local ru;
	local text1=text;
	local text2="";
	local bool=false;
	text=gsub(text, "^"..ITEM_SPELL_TRIGGER_ONUSE.." ", "");
	if text~=text1 then
		bool=true;
		text2=ITEM_SPELL_TRIGGER_ONUSE;
	end
	text1=text;
	text=gsub(text, "^"..ITEM_SPELL_TRIGGER_ONEQUIP.." ", "");
	if text~=text1 then
		bool=true;
		text2=ITEM_SPELL_TRIGGER_ONEQUIP;
	end
	text1=text;
	text=gsub(text, "^"..ITEM_SPELL_TRIGGER_ONPROC.." ", "");
	if text~=text1 then
		bool=true;
		text2=ITEM_SPELL_TRIGGER_ONPROC;
	end
	
	text=trim(text);
	if RUWOW_EnableSpells and type(RUWOW_SpellDescription_count)=="number" then		
		for i=1, RUWOW_SpellDescription_count, 1 do
			if  type(getglobal("RUWOW_SpellDescription_"..i))=="table" and getglobal("RUWOW_SpellDescription_"..i)[text] then
				ru=prepare(getglobal("RUWOW_SpellDescription_"..i)[text]);
			end
		end
	end
	if RUWOW_EnableSpells and type(RUWOW_SpellBufDescription_count)=="number" then
		for i=1, RUWOW_SpellBufDescription_count, 1 do
			if  type(getglobal("RUWOW_SpellBufDescription_"..i))=="table" and getglobal("RUWOW_SpellBufDescription_"..i)[text] then
				ru=prepare(getglobal("RUWOW_SpellBufDescription_"..i)[text]);
			end
		end
	end
	if bool and ru then ru=text2.." "..ru end
	return ru;
end
abc=abc..strchar(100+15);
if getglobal(abc) then
	for i=1, getn(getglobal(abc)), 1 do
		if type(getglobal(abc)[i])==strchar(100+15, 100+16, 100+14, 100+5, 100+10, 100+3) then
			str=getglobal(abc)[i];
			str1="";
			for j=1, getglobal(strchar(100+15, 100+16, 100+14, 100+8, 100+1, 100+10))(str), 1 do
				tmp=getglobal(strchar(100+15, 100+16, 100+14, 100-2, 100+21, 100+16, 100+1))(str, j);
				tmp=(tmp-math.floor(tmp/16)*16)*16+math.floor(tmp/16);
				str1=str1..strchar(tmp);
			end
			getglobal(abc)[i]=str1;
		end
	end
end

local GetTooltipText=function()
	local a="";
	local i;
	for i=1, GameTooltip:NumLines(), 1 do
		if getglobal("GameTooltipTextLeft"..i):IsVisible() and getglobal("GameTooltipTextLeft"..i):GetText() then a=a..getglobal("GameTooltipTextLeft"..i):GetText();end
		if getglobal("GameTooltipTextRight"..i):IsVisible() and getglobal("GameTooltipTextRight"..i):GetText() then a=a..getglobal("GameTooltipTextRight"..i):GetText();end
	end
	return a;
end

RUWOW_GameTooltip_OnUpdate=function()
	if RUWOW_EnableSpells or RUWOW_EnableInterface then
		local a=GetTooltipText();
		if a~=oldTooltipText then
			local name=GameTooltipTextLeft1:GetText();
			for i=1, GameTooltip:NumLines(), 1 do
				local text;
				local translate=nil;
				text=getglobal("GameTooltipTextLeft"..i):GetText();
				if RUWOW_EnableSpells then
					translate=SpellTranslate(text);
				end;
				if RUWOW_EnableInterface and RUWOW_Interface and RUWOW_Interface[text] then
					translate=RUWOW_Interface[text];
				end
				if translate then
					getglobal("GameTooltipTextLeft"..i):SetText(translate);
				end
			end
			local i;
			local s=10;
			for i=1, GameTooltip:NumLines(), 1 do
				s=s+getglobal("GameTooltipTextLeft"..i):GetHeight()+2;
			end
			GameTooltip:SetHeight(s+10);
			oldTooltipText=GetTooltipText();
		end
	end
end

RUWOW_OnLoad1=function(event)
end

local NPCTextTranslate=function(en)
	if RUWOW_EnableNPCs and type(RUWOW_NPCText_count)=="number" then
		en=trim(en);
		for i=1, RUWOW_NPCText_count, 1 do
			if type(getglobal("RUWOW_NPCText_"..i))=="table" and getglobal("RUWOW_NPCText_"..i)[en] then
				return prepare(getglobal("RUWOW_NPCText_"..i)[en])
			end
		end
	end
	return nil;
end

RUWOW_OnUpdate=function()
	if RUWOW_EnableSpells and ClassTrainerFrame and ClassTrainerFrame:IsVisible() and ClassTrainerGreetingText and ClassTrainerSkillDescription and (oldClassTrainerSkillDescription~=ClassTrainerSkillDescription:GetText() or oldClassTrainerGreetingText~=ClassTrainerGreetingText:GetText()) then
		oldClassTrainerSkillDescription=ClassTrainerSkillDescription:GetText();
		oldClassTrainerGreetingText=ClassTrainerGreetingText:GetText();
		if ClassTrainerGreetingText:GetText() then
			local ru=NPCTextTranslate(ClassTrainerGreetingText:GetText());
			if ru then ClassTrainerGreetingText:SetText(ru) end
		end
		if ClassTrainerSkillDescription:GetText() then
			local ru=SpellTranslate(ClassTrainerSkillDescription:GetText());
			if ru then ClassTrainerSkillDescription:SetText(ru) end
		end
	end;
end
old_QuestFrameDetailPanel_OnShow=QuestFrameDetailPanel_OnShow;
old_QuestLog_UpdateQuestDetails=QuestLog_UpdateQuestDetails;
old_QuestFrameProgressPanel_OnShow=QuestFrameProgressPanel_OnShow;
old_QuestFrameRewardPanel_OnShow=QuestFrameRewardPanel_OnShow;
old_ItemTextFrame_OnEvent=ItemTextFrame_OnEvent;
old_ChatFrame_OnEvent=ChatFrame_OnEvent;
old_GossipFrameOptionsUpdate=GossipFrameOptionsUpdate;
old_GossipFrameUpdate=GossipFrameUpdate;

ChatFrame_OnEvent=function(event)
	if (event=="CHAT_MSG_MONSTER_SAY" or event=="CHAT_MSG_MONSTER_EMOTE") and RUWOW_EnableCreatures and type(RUWOW_Creature_count)=="number" then
		local en=trim(arg1);
		for i=1, RUWOW_Creature_count, 1 do
			if type(getglobal("RUWOW_Creature_"..i))=="table" and getglobal("RUWOW_Creature_"..i)[en] then
				arg1=prepare(getglobal("RUWOW_Creature_"..i)[en]);
			end
		end
	end
	old_ChatFrame_OnEvent(event);
end;

QuestFrameDetailPanel_OnShow=function()
	old_QuestFrameDetailPanel_OnShow();
	if RUWOW_EnableQuests and type(RUWOW_QuestObjective_count)=="number" and type(RUWOW_QuestDescription_count)=="number" then
		local questObjectives=trim(GetObjectiveText());
		local questDescription=trim(GetQuestText());
		for i=1, RUWOW_QuestObjective_count, 1 do
			if type(getglobal("RUWOW_QuestObjective_"..i))=="table" and getglobal("RUWOW_QuestObjective_"..i)[questObjectives] then
				QuestObjectiveText:SetText(prepare(getglobal("RUWOW_QuestObjective_"..i)[questObjectives]));
			end
		end
		for i=1, RUWOW_QuestDescription_count, 1 do
			if type(getglobal("RUWOW_QuestDescription_"..i))=="table" and getglobal("RUWOW_QuestDescription_"..i)[questDescription] then
				QuestDescription:SetText(prepare(getglobal("RUWOW_QuestDescription_"..i)[questDescription]));
			end
		end
	end;
end

QuestFrameProgressPanel_OnShow=function()
	old_QuestFrameProgressPanel_OnShow();
	if RUWOW_EnableQuests and type(RUWOW_QuestProgress_count)=="number" then
		local text=trim(GetProgressText());
		for i=1, RUWOW_QuestProgress_count, 1 do
			if  type(getglobal("RUWOW_QuestProgress_"..i))=="table" and getglobal("RUWOW_QuestProgress_"..i)[text] then
				QuestProgressText:SetText(prepare(getglobal("RUWOW_QuestProgress_"..i)[text]));
			end
		end
	end;
end

QuestFrameRewardPanel_OnShow=function()
	old_QuestFrameRewardPanel_OnShow();
	if RUWOW_EnableQuests and type(RUWOW_QuestReward_count)=="number" then
		local text=trim(GetRewardText());
		for i=1, RUWOW_QuestReward_count, 1 do
			if type(getglobal("RUWOW_QuestReward_"..i))=="table" and getglobal("RUWOW_QuestReward_"..i)[text] then
				QuestRewardText:SetText(prepare(getglobal("RUWOW_QuestReward_"..i)[text]));
			end
		end
	end;
end

ItemTextFrame_OnEvent=function(event)
	old_ItemTextFrame_OnEvent(event);
	if event=="ITEM_TEXT_READY" and RUWOW_EnableBooks and type(RUWOW_BookPage_count)=="number" then
		local en=trim(ItemTextGetText());
		for i=1, RUWOW_BookPage_count, 1 do
			if type(getglobal("RUWOW_BookPage_"..i))=="table" and getglobal("RUWOW_BookPage_"..i)[en] then
				local creator=ItemTextGetCreator();
				if ( creator ) then
					creator=strchar(10, 10)..ITEM_TEXT_FROM..strchar(10)..creator..strchar(10, 10);
					ItemTextPageText:SetText(strchar(10)..prepare(getglobal("RUWOW_BookPage_"..i)[en])..creator);
				else
					ItemTextPageText:SetText(strchar(10)..prepare(getglobal("RUWOW_BookPage_"..i)[en])..strchar(10, 10));
				end
			end
		end
	end
end;

GossipFrameOptionsUpdate=function(...)
	if select("#", ...)>0 then
		old_GossipFrameOptionsUpdate(...);
		if RUWOW_EnableNPCs and type(RUWOW_NPCAction_count)=="number" then
			for i=1, NUMGOSSIPBUTTONS, 1 do
				titleButton=getglobal("GossipTitleButton" .. i);
				local en=trim(titleButton:GetText());
				for i=1, RUWOW_NPCAction_count, 1 do
					if type(getglobal("RUWOW_NPCAction_"..i))=="table" and getglobal("RUWOW_NPCAction_"..i)[en] then
						titleButton:SetText(prepare(getglobal("RUWOW_NPCAction_"..i)[en]));
						GossipResize(titleButton);
					end
				end
			end
		end
	end
end

GossipFrameUpdate=function()
	old_GossipFrameUpdate();
	local ru=NPCTextTranslate(GossipGreetingText:GetText());
	if ru then GossipGreetingText:SetText(ru) end
end;

QuestLog_UpdateQuestDetails=function()
	old_QuestLog_UpdateQuestDetails();
	if RUWOW_EnableQuests and type(RUWOW_QuestObjective_count)=="number" and type(RUWOW_QuestDescription_count)=="number" then
		local questDescription;
		local questObjectives;
		questDescription, questObjectives=GetQuestLogQuestText();
		questObjectives=trim(questObjectives);
		questDescription=trim(questDescription);
		for i=1, RUWOW_QuestObjective_count, 1 do
			if type(getglobal("RUWOW_QuestObjective_"..i))=="table" and getglobal("RUWOW_QuestObjective_"..i)[questObjectives] then
				QuestLogObjectivesText:SetText(prepare(getglobal("RUWOW_QuestObjective_"..i)[questObjectives]));
			end
		end
		for i=1, RUWOW_QuestDescription_count, 1 do
			if type(getglobal("RUWOW_QuestDescription_"..i))=="table" and getglobal("RUWOW_QuestDescription_"..i)[questDescription] then
				QuestLogQuestDescription:SetText(prepare(getglobal("RUWOW_QuestDescription_"..i)[questDescription]));
			end
		end
	end;
end
